-- SpecialTwinWheelsFunctions
-- Specialisation for Special Wheels from "John Deere Old Version Pack"
-- @ Autor  Tobias F. (John Deere 6930 @ 1. Ls-Modschmiede http://landwirtschaftssimulator-mods.de/)
-- @ Last Edit  28/12/2009
SpecialTwinWheelsFunctions = {};
function SpecialTwinWheelsFunctions.prerequisitesPresent(specializations)
    return true;
end;

function SpecialTwinWheelsFunctions:load(xmlFile)
	self.UpdateWheelNodes = SpecializationUtil.callSpecializationsFunction("UpdateWheelNodes");
	self.UpdateWheelTwinNodes = SpecializationUtil.callSpecializationsFunction("UpdateWheelTwinNodes");
	self.Wheels = {}
	self.WheelsSelect = 0;
	self.WheelsSelectMax = 9;
	self.Wheels.nodes = {}
	self.Wheels.nodes.RB = {}
	self.Wheels.nodes.RB = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Wheels.nodes#RB"));
	self.Wheels.nodes.RBloaded = nil;
	self.Wheels.nodes.LB = {}
	self.Wheels.nodes.LB = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Wheels.nodes#LB"));
	self.Wheels.nodes.LBloaded = nil;
	self.Wheels.nodes.RF = {}
	self.Wheels.nodes.RF = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Wheels.nodes#RF"));
	self.Wheels.nodes.RFloaded = nil;
	self.Wheels.nodes.LF = {}
	self.Wheels.nodes.LF = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Wheels.nodes#LF"));
	self.Wheels.nodes.LFloaded = nil;
	
	if not ((self.Wheels.nodes.RB or self.Wheels.nodes.LB or self.Wheels.nodes.RF or self.Wheels.nodes.LF) == nil) then
		self.Wheels.Normal = {}
		self.Wheels.Normal.RB  = Utils.getFilename(getXMLString(xmlFile, "vehicle.Wheels.Normal.RB#file"), self.baseDirectory);
		self.Wheels.Normal.LB  = Utils.getFilename(getXMLString(xmlFile, "vehicle.Wheels.Normal.LB#file"), self.baseDirectory);
		self.Wheels.Normal.RF  = Utils.getFilename(getXMLString(xmlFile, "vehicle.Wheels.Normal.RF#file"), self.baseDirectory);
		self.Wheels.Normal.LF  = Utils.getFilename(getXMLString(xmlFile, "vehicle.Wheels.Normal.LF#file"), self.baseDirectory);
		if (self.Wheels.Normal.RB or self.Wheels.Normal.LB or self.Wheels.Normal.RF or self.Wheels.Normal.LF) == nil then
			self:UpdateWheelNodes(nil, nil, nil, nil);
			print("Warning: No Normal Wheels given!")
		else
			self:UpdateWheelNodes(self.Wheels.Normal.RB, self.Wheels.Normal.LB, self.Wheels.Normal.RF, self.Wheels.Normal.LF);
		end;
		self.Wheels.Terra = {}
		if getXMLBool(xmlFile, "vehicle.Wheels#HasTerras") then
			self.Wheels.Terra.RB  = Utils.getFilename(getXMLString(xmlFile, "vehicle.Wheels.Terra.RB#file"), self.baseDirectory);
			self.Wheels.Terra.LB  = Utils.getFilename(getXMLString(xmlFile, "vehicle.Wheels.Terra.LB#file"), self.baseDirectory);
			self.Wheels.Terra.RF  = Utils.getFilename(getXMLString(xmlFile, "vehicle.Wheels.Terra.RF#file"), self.baseDirectory);
			self.Wheels.Terra.LF  = Utils.getFilename(getXMLString(xmlFile, "vehicle.Wheels.Terra.LF#file"), self.baseDirectory);
		end;
		self.Wheels.Pesticide = {}
		if getXMLBool(xmlFile, "vehicle.Wheels#HasPesticides") then
			self.Wheels.Pesticide.RB  = Utils.getFilename(getXMLString(xmlFile, "vehicle.Wheels.Pesticide.RB#file"), self.baseDirectory);
			self.Wheels.Pesticide.LB  = Utils.getFilename(getXMLString(xmlFile, "vehicle.Wheels.Pesticide.LB#file"), self.baseDirectory);
			self.Wheels.Pesticide.RF  = Utils.getFilename(getXMLString(xmlFile, "vehicle.Wheels.Pesticide.RF#file"), self.baseDirectory);
			self.Wheels.Pesticide.LF  = Utils.getFilename(getXMLString(xmlFile, "vehicle.Wheels.Pesticide.LF#file"), self.baseDirectory);
		end;
	end;
		
	self.Wheels.hasTwins = Utils.getNoNil(getXMLBool(xmlFile, "vehicle.Wheels#HasTwins"), false);
	if self.Wheels.hasTwins then
		self.Wheels.Twinnodes = {}
		self.Wheels.Twinnodes.RB = {}
		self.Wheels.Twinnodes.RB = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Wheels.Twinnodes#RB"));
		self.Wheels.Twinnodes.RBloaded = nil;
		self.Wheels.Twinnodes.LB = {}
		self.Wheels.Twinnodes.LB = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Wheels.Twinnodes#LB"));
		self.Wheels.Twinnodes.LBloaded = nil;
		self.Wheels.Twinnodes.RF = {}
		self.Wheels.Twinnodes.RF = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Wheels.Twinnodes#RF"));
		self.Wheels.Twinnodes.RFloaded = nil;
		self.Wheels.Twinnodes.LF = {}
		self.Wheels.Twinnodes.LF = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Wheels.Twinnodes#LF"));
		self.Wheels.Twinnodes.LFloaded = nil;
		self:UpdateWheelTwinNodes(nil, nil, nil, nil);		
		if not ((self.Wheels.Twinnodes.RB or self.Wheels.Twinnodes.LB or self.Wheels.Twinnodes.RF or self.Wheels.Twinnodes.LF) == nil) then
			self.Wheels.Normal.Twin = {}
			if getXMLBool(xmlFile, "vehicle.Wheels#HasNormalTwins") then
				self.Wheels.Normal.Twin.RB  = Utils.getFilename(getXMLString(xmlFile, "vehicle.Wheels.Normal.Twin.RB#file"), self.baseDirectory);
				self.Wheels.Normal.Twin.LB  = Utils.getFilename(getXMLString(xmlFile, "vehicle.Wheels.Normal.Twin.LB#file"), self.baseDirectory);
				self.Wheels.Normal.Twin.RF  = Utils.getFilename(getXMLString(xmlFile, "vehicle.Wheels.Normal.Twin.RF#file"), self.baseDirectory);
				self.Wheels.Normal.Twin.LF  = Utils.getFilename(getXMLString(xmlFile, "vehicle.Wheels.Normal.Twin.LF#file"), self.baseDirectory);
			end;
			self.Wheels.Pesticide.Twin = {}
			if getXMLBool(xmlFile, "vehicle.Wheels#HasPesticides") then
				if getXMLBool(xmlFile, "vehicle.Wheels#HasPesticidesTwins") then
					self.Wheels.Pesticide.Twin.RB = Utils.getFilename(getXMLString(xmlFile, "vehicle.Wheels.Pesticide.Twin.RB#file"), self.baseDirectory);
					self.Wheels.Pesticide.Twin.LB = Utils.getFilename(getXMLString(xmlFile, "vehicle.Wheels.Pesticide.Twin.LB#file"), self.baseDirectory);
					self.Wheels.Pesticide.Twin.RF = Utils.getFilename(getXMLString(xmlFile, "vehicle.Wheels.Pesticide.Twin.RF#file"), self.baseDirectory);
					self.Wheels.Pesticide.Twin.LF = Utils.getFilename(getXMLString(xmlFile, "vehicle.Wheels.Pesticide.Twin.LF#file"), self.baseDirectory);
				end;
			end;
		end;
	end;
	self.runOnlyOnes1 = true;
	self.runOnlyOnes2 = true;
	self.runOnlyOnes3 = true;
	self.runOnlyOnes4 = true;
	self.runOnlyOnes5 = true;
	self.runOnlyOnes6 = true;
	self.runOnlyOnes7 = true;
	self.runOnlyOnes8 = true;
end;

function SpecialTwinWheelsFunctions:delete()
end;
function SpecialTwinWheelsFunctions:mouseEvent(posX, posY, isDown, isUp, button)
end;
function SpecialTwinWheelsFunctions:keyEvent(unicode, sym, modifier, isDown)
end;
       
	   
function SpecialTwinWheelsFunctions:update(dt)
	if self:getIsActiveForInput() then
		if InputBinding.hasEvent(InputBinding.DF7807_WHEELS) then
			self.WheelsSelect = self.WheelsSelect +1;
		end;
	end;
	
	if self.WheelsSelect >= self.WheelsSelectMax then
		self.WheelsSelect = 1;
		self.runOnlyOnes1 = true;
		self.runOnlyOnes2 = true;
		self.runOnlyOnes3 = true;
		self.runOnlyOnes4 = true;
		self.runOnlyOnes5 = true;
		self.runOnlyOnes6 = true;
		self.runOnlyOnes7 = true;
		self.runOnlyOnes8 = true;
	end;
	
	if self.WheelsSelect == 1 then
		--Normal + Back Twins
		if self.runOnlyOnes1 then
			if self.Wheels.hasTwins and (self.Wheels.Normal.Twin.RB and self.Wheels.Normal.Twin.LB and self.Wheels.Normal.Twin.RF and self.Wheels.Normal.Twin.LF) ~= nil then
				self:UpdateWheelTwinNodes(nil, nil, nil, nil);
				self:UpdateWheelTwinNodes(self.Wheels.Normal.Twin.RB, self.Wheels.Normal.Twin.LB, nil, nil);
			else
				self.WheelsSelect = 3
			end;
			self.runOnlyOnes1 = false;
		end;
	elseif self.WheelsSelect == 2 then
		--Normal + Twins
		if self.runOnlyOnes2 then
			if (self.Wheels.Normal.Twin.RB and self.Wheels.Normal.Twin.LB and self.Wheels.Normal.Twin.RF and self.Wheels.Normal.Twin.LF) ~= nil then
				self:UpdateWheelTwinNodes(nil, nil, nil, nil);
				self:UpdateWheelTwinNodes(self.Wheels.Normal.Twin.RB, self.Wheels.Normal.Twin.LB, self.Wheels.Normal.Twin.RF, self.Wheels.Normal.Twin.LF);
			else
				self.WheelsSelect = 8
			end;
			self.runOnlyOnes2 = false;
		end;
	elseif self.WheelsSelect == 3 then
		--Normal Front + Terra
		if self.runOnlyOnes3 then
			self:UpdateWheelNodes(nil, nil, nil, nil);
			if self.Wheels.hasTwins then
				self:UpdateWheelTwinNodes(nil, nil, nil, nil);
			end;
			if (self.Wheels.Terra.RB and self.Wheels.Terra.LB and self.Wheels.Terra.RF and self.Wheels.Terra.LF) ~= nil then
				self:UpdateWheelNodes(self.Wheels.Terra.RB, self.Wheels.Terra.LB, self.Wheels.Normal.RF, self.Wheels.Normal.LF);
			else
				self.WheelsSelect = 5
			end;
			self.runOnlyOnes3 = false;
		end;
	elseif self.WheelsSelect == 4 then
		--Terra
		if self.runOnlyOnes4 then
			if (self.Wheels.Terra.RB and self.Wheels.Terra.LB and self.Wheels.Terra.RF and self.Wheels.Terra.LF) ~= nil then
				self:UpdateWheelNodes(nil, nil, nil, nil);
				self:UpdateWheelNodes(self.Wheels.Terra.RB, self.Wheels.Terra.LB, self.Wheels.Terra.RF, self.Wheels.Terra.LF);
			else
				self.WheelsSelect = 5
			end;	
			self.runOnlyOnes3 = false;
		end;
		elseif self.WheelsSelect == 5 then
		--Pesticide
		if self.runOnlyOnes5 then
			self:UpdateWheelNodes(nil, nil, nil, nil);
			if (self.Wheels.Pesticide.RB and self.Wheels.Pesticide.LB and self.Wheels.Pesticide.RF and self.Wheels.Pesticide.LF) ~= nil then
				self:UpdateWheelNodes(self.Wheels.Pesticide.RB, self.Wheels.Pesticide.LB, self.Wheels.Pesticide.RF, self.Wheels.Pesticide.LF);
			else
				self.WheelsSelect = 8
			end;
			self.runOnlyOnes5 = false;
		end;
	elseif self.WheelsSelect == 6 then
		--Pesticide + Pesticide Twins Back
		if self.runOnlyOnes6 then
			if self.Wheels.hasTwins and (self.Wheels.Pesticide.Twin.RB and self.Wheels.Pesticide.Twin.LB and self.Wheels.Pesticide.Twin.RF and self.Wheels.Pesticide.Twin.LF) ~= nil then
				self:UpdateWheelTwinNodes(nil, nil, nil, nil);
				self:UpdateWheelTwinNodes(self.Wheels.Pesticide.Twin.RB, self.Wheels.Pesticide.Twin.LB, nil, nil);
			else
				self.WheelsSelect = 8
			end;
			self.runOnlyOnes6 = false;
		end;
	elseif self.WheelsSelect == 7 then
		--Pesticide + Pesticide Twins
		if self.runOnlyOnes7 then
			if (self.Wheels.Pesticide.Twin.RB and self.Wheels.Pesticide.Twin.LB and self.Wheels.Pesticide.Twin.RF and self.Wheels.Pesticide.Twin.LF) ~= nil then
				self:UpdateWheelTwinNodes(nil, nil, nil, nil);
				self:UpdateWheelTwinNodes(self.Wheels.Pesticide.Twin.RB, self.Wheels.Pesticide.Twin.LB, self.Wheels.Pesticide.Twin.RF, self.Wheels.Pesticide.Twin.LF);
			else
				self.WheelsSelect = 8
			end;
			self.runOnlyOnes7 = false;
		end;
	elseif self.WheelsSelect == 8 then
		--Normal
		if self.runOnlyOnes8 then
			self:UpdateWheelNodes(nil, nil, nil, nil);
			if self.Wheels.hasTwins then
				self:UpdateWheelTwinNodes(nil, nil, nil, nil);
			end;
			self:UpdateWheelNodes(self.Wheels.Normal.RB, self.Wheels.Normal.LB, self.Wheels.Normal.RF, self.Wheels.Normal.LF);
			self.runOnlyOnes8 = false;
		end;
	end;	
end;
	
function SpecialTwinWheelsFunctions:UpdateWheelTwinNodes(curRBTwin,curLBTwin,curRFTwin, curLFTwin)
	if curRBTwin ~= nil then
		if self.Wheels.Twinnodes.RBloaded == nil then
			local i3dNodesTwinRB = loadI3DFile(curRBTwin);
			if i3dNodesTwinRB ~= 0 then
				link(self.Wheels.Twinnodes.RB, i3dNodesTwinRB);
				self.Wheels.Twinnodes.RBloaded = i3dNodesTwinRB;
			end;
		end;
	else
		delete(self.Wheels.Twinnodes.RBloaded);
		self.Wheels.Twinnodes.RBloaded = nil;
	end;	
	if curLBTwin ~= nil then
		if self.Wheels.Twinnodes.LBloaded == nil then
			local i3dNodesTwinLB = loadI3DFile(curLBTwin);
			if i3dNodesTwinLB ~= 0 then
				link(self.Wheels.Twinnodes.LB, i3dNodesTwinLB);
				self.Wheels.Twinnodes.LBloaded = i3dNodesTwinLB;
			end;
		end;
	else
		delete(self.Wheels.Twinnodes.LBloaded);
		self.Wheels.Twinnodes.LBloaded = nil;
	end;
	if curRFTwin ~= nil then
		if self.Wheels.Twinnodes.RFloaded == nil then
			local i3dNodesTwinRF = loadI3DFile(curRFTwin);
			if i3dNodesTwinRF ~= 0 then
				link(self.Wheels.Twinnodes.RF, i3dNodesTwinRF);
				self.Wheels.Twinnodes.RFloaded = i3dNodesTwinRF;
			end;
		end;
	else
		delete(self.Wheels.Twinnodes.RFloaded);
		self.Wheels.Twinnodes.RFloaded = nil;
	end;
	if curLFTwin ~= nil then
		if self.Wheels.Twinnodes.LFloaded == nil then
			local i3dNodesTwinLF = loadI3DFile(curLFTwin);
			if i3dNodesTwinLF ~= 0 then
				link(self.Wheels.Twinnodes.LF, i3dNodesTwinLF);
				self.Wheels.Twinnodes.LFloaded = i3dNodesTwinLF;
			end;
		end;
	else
		delete(self.Wheels.Twinnodes.LFloaded);
		self.Wheels.Twinnodes.LFloaded = nil;
	end;	
end;

function SpecialTwinWheelsFunctions:UpdateWheelNodes(curRB,curLB,curRF, curLF)
	if curRB ~= nil then
		if self.Wheels.nodes.RBloaded == nil then
			local i3dNodesRB = loadI3DFile(curRB);
			if i3dNodesRB ~= 0 then
				link(self.Wheels.nodes.RB, i3dNodesRB);
				self.Wheels.nodes.RBloaded = i3dNodesRB;
			end;
		end;
	else
		delete(self.Wheels.nodes.RBloaded);
		self.Wheels.nodes.RBloaded = nil;
	end;	
	if curLB ~= nil then
		if self.Wheels.nodes.LBloaded == nil then
			local i3dNodesLB = loadI3DFile(curLB);
			if i3dNodesLB ~= 0 then
				link(self.Wheels.nodes.LB, i3dNodesLB);
				self.Wheels.nodes.LBloaded = i3dNodesLB;
			end;
		end;
	else
		delete(self.Wheels.nodes.LBloaded);
		self.Wheels.nodes.LBloaded = nil;
	end;		
	if curRF ~= nil then
		if self.Wheels.nodes.RFloaded == nil then
			local i3dNodesRF = loadI3DFile(curRF);
			if i3dNodesRF ~= 0 then
				link(self.Wheels.nodes.RF, i3dNodesRF);
				self.Wheels.nodes.RFloaded = i3dNodesRF;
			end;
		end;
	else
		delete(self.Wheels.nodes.RFloaded);
		self.Wheels.nodes.RFloaded = nil;
	end;	
	if curLF ~= nil then
		if self.Wheels.nodes.LFloaded == nil then
			local i3dNodesLF = loadI3DFile(curLF);
			if i3dNodesLF ~= 0 then
				link(self.Wheels.nodes.LF, i3dNodesLF);
				self.Wheels.nodes.LFloaded = i3dNodesLF;
			end;
		end;
	else
		delete(self.Wheels.nodes.LFloaded);
		self.Wheels.nodes.LFloaded = nil;
	end;	
end;
function SpecialTwinWheelsFunctions:draw()
end;